;---------------------------------------------------------------
; Codec Windows-1251
;  Windows-1251
;---------------------------------------------------------------

comment * ======================================================

                          
                             MASM32

  . ():
ml /c /coff "console.asm"
PoLink /SUBSYSTEM:CONSOLE "console.obj"

: devices-list v.1.00 beta3
:  ..
 2020

 . Freeware, OpenSource. " ".
sadovoya@mtu-net.ru
sadovoya.narod.ru


================================================================ *

include    \masm32\include\masm32rt.inc
include    \masm32\include\setupapi.inc
includelib \masm32\lib\setupapi.lib

SP_DEVINFO_DATA struct
        cbSize    dd ?
        ClassGuid db 16 dup(?) ;GUID 128 bit
        DevInst   dd ?
        Reserved  dd ?         ;ULONG_PTR 32 / 64 bit
SP_DEVINFO_DATA   ends

.data
     ConsoleCaption db ' ',0
     TitleText      db ' :',0
     PressKey       db '    ...',0
     ResultStr      db '****  main   %d  ****',0
     ErrorStr       db '...',0 

.data?
     DeviceInfoData SP_DEVINFO_DATA <?>
     Buffer db 1024 dup(?) ; 
     delt_t dd ?

.code

start:
    ;  
    invoke CharToOem, offset ConsoleCaption, offset Buffer
    SetConsoleCaption offset Buffer
    
    ;  
    invoke CharToOem, offset TitleText, offset Buffer
    print offset Buffer,13,10,13,10

    ;    main()---------------

    call GetTickCount
    mov delt_t, eax

    call main

    call GetTickCount
    sub eax, delt_t
    xchg eax, delt_t

    ;------------------------------------------------
    
    ;   
    print " ",13,10	
    invoke CharToOem, offset ResultStr, offset Buffer
    printf(offset Buffer, delt_t)
    print " ",13,10,13,10
    
    invoke CharToOem, offset PressKey, offset Buffer
    inkey offset Buffer	

    exit 0



;  
main proc

    LOCAL lst    : DWORD ;HDEVINFO
    LOCAL number : DWORD ; .
    LOCAL k      : DWORD


    mov lst, 0
    mov number, 0
    mov k, 0
    mov DeviceInfoData.cbSize, sizeof DeviceInfoData

    mov eax, DIGCF_ALLCLASSES
    or eax,  DIGCF_PRESENT
    invoke SetupDiGetClassDevsA, 0, 0, 0, eax
    mov lst, eax

    .if lst == INVALID_HANDLE_VALUE
        invoke CharToOem, offset ErrorStr, offset Buffer
        print offset Buffer,13,10,13,10 
        invoke CharToOem, offset PressKey, offset Buffer
        inkey offset Buffer
        exit -1000
    .endif

cycle_beg:
    invoke SetupDiEnumDeviceInfo, lst, k, offset DeviceInfoData
    .if eax != 0
        invoke SetupDiGetDeviceRegistryPropertyA, lst, offset DeviceInfoData, 
	    SPDRP_FRIENDLYNAME, 0, offset Buffer, sizeof Buffer, 0
        .if eax != 0
            invoke CharToOem, offset Buffer, offset Buffer
            inc number
            printf("%d : %s\n", number, offset Buffer)
        .else
            invoke SetupDiGetDeviceRegistryPropertyA, lst, offset DeviceInfoData,
	        SPDRP_DEVICEDESC, 0, offset Buffer, sizeof Buffer, 0		
	    .if eax != 0
                invoke CharToOem, offset Buffer, offset Buffer
                inc number
                printf("%d : %s\n", number, offset Buffer)
	    .endif
        .endif  
         
        inc k ;    number
        jmp cycle_beg
    .endif

    ; lst
    invoke SetupDiDestroyDeviceInfoList, lst	

    ret

main endp


end start
